;; Copyright (c) 2006 Carlos Ungil

;; Permission is hereby granted, free of charge, to any person obtaining
;; a copy of this software and associated documentation files (the
;; "Software"), to deal in the Software without restriction, including
;; without limitation the rights to use, copy, modify, merge, publish,
;; distribute, sublicense, and/or sell copies of the Software, and to
;; permit persons to whom the Software is furnished to do so, subject to
;; the following conditions:

;; The above copyright notice and this permission notice shall be
;; included in all copies or substantial portions of the Software.

;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
;; NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
;; LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
;; OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
;; WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

(in-package :rcl)

;; for CMUCL: the shell variable R_HOME has to be set to the value
;; below *before* the lisp interpreter is executed
(eval-when (:compile-toplevel :load-toplevel :execute)
  (defvar *r-home* 
    #+darwin "/Library/Frameworks/R.framework/Resources/"
    #+windows "c:/Program Files/R/R-2.7.2/"
    #-(or darwin windows) "/usr/lib/R/")
  (defvar *r-lib-name*
    #+windows "R"
    #-windows "libR")
  (defvar *r-lib-extension*
    #+windows ".dll"
    #+darwin ".dylib"
    #-(or darwin windows) ".so")
  (defvar *r-lib* 
    (concatenate 'string *r-lib-name* *r-lib-extension*))
  (defvar *r-lib-path* 
    (concatenate 'string *r-home* 
		 #+windows "bin/"
		 #-windows "lib/")))


